package edu.kit.ipd.descartes.adaptation.model.repository.perfdatarepo;

import static edu.kit.ipd.descartes.adaptation.model.repository.perfdatarepo.PerfDataRepoConverter.convertObservableImpact;

import org.apache.log4j.Logger;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;

import edu.kit.ipd.descartes.adaptation.model.repository.AbstractEcoreModelLoader;
import edu.kit.ipd.descartes.perfdatarepo.Impact;
import edu.kit.ipd.descartes.perfdatarepo.Result;
import edu.kit.ipd.descartes.ql.models.repository.Observation;
import edu.kit.ipd.descartes.ql.models.repository.ObservationRepository;
//import edu.kit.ipd.descartes.adaptation.model.repository.dmm.AdaptationProcessModelLoader;

public class ObservationRepositoryHandler implements IPerformanceDataRepositoryHandler {

    private static Logger logger = Logger.getLogger(ObservationRepositoryHandler.class);
    private AbstractEcoreModelLoader modelLoader = null;
    private ObservationRepository repository = null;

    public ObservationRepositoryHandler() {
        modelLoader = ObservationRepositoryModelLoader.getInstance();
        logger.debug("ObservationRepositoryHandler loaded.");
    }

    @Override
    public Impact getLatestImpact() {
        return convertObservableImpact(repository.getLatestImpact());
    }

    @Override
    public void load(String modelFileUri) {
        repository = (ObservationRepository) modelLoader.load(URI.createFileURI(modelFileUri));
    }

    @Override
    public Result getCurrentSystemState() {
        Observation o = repository.getLatestObservation();

//        WeightedTactic latestTactic = TacticsHistory.getInstance().getLatestAppliedTactic();
//        if (latestTactic == null) {
//            o = repository.getLatestObservation();
//        } else {
//            // TODO: Blue Yonder specific, introduce abstraction layer
//            String expName = BlueYonderExperimentTracker.getInstance.getExperimentNameForDistributedDataCenter(AdaptationProcessModelLoader.getDistributedDataCenter());
//            logger.debug("Searching for result of " + expName);
//            o = ObservationRepositoryHelper.getResultEndingWith(expName, repository);
//        }

        if (o == null)
            return null;
        else 
            return PerfDataRepoConverter.convertResult(o);
    }

    @Override
    public EObject getRepository() {
        return repository;
    }

}
